
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Gabor滤波器学习 / iVAN</title>

    <meta name="description" content="Gabor滤波器学习   本文的目的是用C实现生成Gabor模版,并对图像卷积.并简单提一下,Gabor滤波器在纹理特征提取上的应用. 一.什么是Gabor函数(以下内容含部分翻译自维基百科)   在图像处理中,Gabor函数是一个用于边缘提取的线性滤波器.Gabor滤波器的频率和方向表达同人类视觉系统类似.研究发现,Gabor滤波器十分适合纹理表达和分离.在空间域中,一个二维Gabor滤波器是一个由正弦平面波调制的高斯核函数.   还有,生物学实验发现,Gabor滤波器可以很好地近似单细胞的感受野函数(光强刺激下的">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Gabor滤波器学习</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>  本文的目的是用C实现生成Gabor模版，并对图像卷积。并简单提一下，Gabor滤波器在纹理特征提取上的应用。</p>
<p>一、什么是Gabor函数（以下内容含部分翻译自维基百科）</p>
<p>  在图像处理中，Gabor函数是一个用于边缘提取的线性滤波器。Gabor滤波器的频率和方向表达同人类视觉系统类似。研究发现，Gabor滤波器十分适合纹理表达和分离。在空间域中，一个二维Gabor滤波器是一个由正弦平面波调制的高斯核函数。</p>
<p>  还有，生物学实验发现，Gabor滤波器可以很好地近似单细胞的感受野函数（光强刺激下的传递函数），什么视皮层内的超柱，bla...bla，总之是这方面仿生的数学模型。</p>
<p>  另外，网上有一种说法，gabor分为实部和虚部，用实部进行滤波后图像会平滑；虚部滤波后用来检测边缘。【来自百度知道某个大神的回答】，我查了文献，发现的确有人用Gabor的奇函数部分做边缘提取（《基于Gabor滤波器的边缘检测算法》 无线电工程 2000年第3卷第30期）。另外，从我的实验结果也有类似的发现。暂且认为这个对的吧。</p>
<p>  Gabor滤波器的脉冲响应，可以定义为一个正弦波（对于二维Gabor滤波器是正弦平面波）乘以高斯函数。由于乘法卷积性质，Gabor滤波器的脉冲响应的傅立叶变换是其调和函数的傅立叶变换和高斯函数傅立叶变换的卷积。该滤波器由实部和虚部组成，二者相互正交。一组不同频率不同方向的Gabor函数数组对于图像特征提取非常有用。</p>
<p>下面给出二维Gabor函数的数学表达：</p>
<p>复数表达：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDAxMDMxOTQ1MDk3MDM=.jpg"></p>
<p>实数部分：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDAxMDMxOTQ1NDEzNzU=.jpg"></p>
<p>虚数部分：</p>
<p>   <img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDAxMDMxOTQ2MTg0NTM=.jpg"></p>
<p>其中：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDAxMDMxOTQ2NDEyMzQ=.jpg"></p>
<p>和</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDAxMDMxOTQ2NTU2MjU=.jpg"></p>
<p>下面介绍公式中各个参数的含义，及参数如何配置问题【都从老外那翻译来的】：</p>
<p>波长（<strong>λ</strong>）：它的值以像素为单位指定，通常大于等于2.但不能大于输入图像尺寸的五分之一。</p>
<p>方向（<strong>θ</strong>）：这个参数指定了Gabor函数并行条纹的方向，它的取值为0到360度</p>
<p>相位偏移（<strong>φ</strong>）：它的取值范围为-180度到180度。其中，0he180度分别对应中心对称的center-on函数和center-off函数，而-90度和90度对应反对称函数。</p>
<p>长宽比（<strong>γ</strong>）：空间纵横比，决定了Gabor函数形状（support，我翻译为形状）的椭圆率（ellipticity）。当γ=<br />
 1时，形状是圆的。当γ&lt; 1时，形状随着平行条纹方向而拉长。通常该值为0.5</p>
<p>带宽（b）：Gabor滤波器的半响应空间频率带宽b和σ/ λ的比率有关，其中σ表示Gabor函数的高斯因子的标准差，如下：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDAxMDMyMDM5Mjc3NjU=.jpg"></p>
<p>σ的值不能直接设置，它仅随着带宽b变化。带宽值必须是正实数，通常为1，此时，标准差和波长的关系为：σ=<br />
 0.56 λ。带宽越小，标准差越大，Gabor形状越大，可见平行兴奋和抑制区条纹数量越多。</p>
<p>下面给出，不同参数配置下的Gabor核函数效果图，大小均100*100：</p>
<p>a.波长对比组【方向为：0，相位偏移量为：0，纵横比率为：0.5，带宽为：1，下图波长分别为5，10，15】</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDAxMDMyMDQ4NTMyOTY=.jpg"></p>
<p>b.方向对比组【波长为：10，相位偏移量为：0，空间纵横比为：0.5，带宽为：1，方向分别为：0，45，90】</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDAxMDMyMDUwMzI4NDM=.jpg"></p>
<p>c.相位偏移量对比组【波长为：10，方向为：0，空间纵横比：0.5，带宽：1，相位偏移量分别为：0，180，-90，90】</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDAxMDMyMDUyNDQ4NDM=.jpg"></p>
<p>d.空间纵横比对比组【波长：10，相位偏移量：0，方向：0，带宽：1，空间纵横比分别为：0.5，1】</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDAxMDMyMDU0NDg4OTA=.jpg"></p>
<p>e.带宽对比组【波长：10，方向：0，相位偏移量：0，空间纵横比：0.5，带宽分别为：0.5，1，2】</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDAxMDMyMDU2MjA5ODQ=.jpg"></p>
<p>二、gabor函数实现：</p>
<p>matlab版本，我从pudn上找来的，但他的gabor函数，我没怎么看明白：</p>
<p>gabor函数：</p>
<pre>function gabor_k = compute(x,y,f0,theta)
r = 1; g = 1;
x1 = x*cos(theta) + y*sin(theta);
y1 = -x*sin(theta) + y*cos(theta);
gabor_k = f0^2/(pi*r*g)*exp(-(f0^2*x1^2/r^2+f0^2*y1^2/g^2))*exp(i*2*pi*f0*x1); </pre>
<p><pre>%绘制一个Gabor滤波器的空域和频域函数图
clear;
x = 0;
theta = 0;
f0 = 0.2;
for i = linspace(-15,15,50)
    x = x + 1;
    y = 0;
    for j = linspace(-15,15,50)
        y = y + 1;
        z(y,x)=compute(i,j,f0,theta);
    end
end
x = linspace(-15,15,50);
y = linspace(-15,15,50);
surf(x,y,real(z))
title('Gabor filter:real component');
xlabel('x');
ylabel('y');
zlabel('z');
figure(2);
surf(x,y,imag(z))
title('Gabor filter:imaginary component');
xlabel('x');
ylabel('y');
zlabel('z');

Z = fft2(z);
u = linspace(-0.5,0.5,50);
v = linspace(-0.5,0.5,50);
figure(3);
surf(u,v,abs(fftshift(Z)))
title('Gabor filter:frequency component');
xlabel('u');
ylabel('v');
zlabel('Z');</pre>
<p>运行结果：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDAxMDMyMTAxMjkyMDM=.jpg"></p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDAxMDMyMTAxNDg2MjU=.jpg"></p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDAxMDMyMTAyMDQwNjI=.jpg"></p>
<p>   </p>
<pre>%4个方向的Gabo滤波器通过图像显示
clear;
x = 0;
theta = pi*3/4;%用弧度0,pi/4,pi/2,pi*3/4
f0 = 0.2;
for i = linspace(-15,15,50)
    x = x + 1;
    y = 0;
    for j = linspace(-15,15,50)
        y = y + 1;
        z(y,x)=compute(i,j,f0,theta);
    end
end
z_real = real(z);
m = min(z_real(:));
z_real = z_real+abs(m);
M = max(z_real(:));
imshow(1/M*z_real);
figure(2)
z_imag = imag(z);
m = min(z_imag(:));
z_imag = z_imag+abs(m);
M = max(z_imag(:));
imshow(1/M*z_imag);
</pre>
<p>运行效果：<br />
<br />实数部分：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDAxMDMyMTA1Mzc0ODQ=.jpg"></p>
<p>虚数部分：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDAxMDMyMTA2MTM5Njg=.jpg"></p>
<pre>%4个方向的Gabor滤波器对lena进行滤波
clear;
I = imread('.\pic\lena.bmp');
f0 = 0.2;
count = 0;
for theta = [0,pi/4,pi/2,pi*3/4];%用弧度0,pi/4,pi/2,pi*3/4
    count = count + 1;
    x = 0;
    for i = linspace(-8,8,11)
        x = x + 1;
        y = 0;
        for j = linspace(-8,8,11)
            y = y + 1;
            z(y,x)=compute(i,j,f0,theta);
        end
    end
    figure(count);
    filtered = filter2(z,I,'valid');
    f = abs(filtered);
    imshow(f/max(f(:)))
end</pre>
<p>运行效果：<br />
<br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDAxMDMyMTA4NDI4NDM=.jpg"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDAxMDMyMTA4NTU4Mjg=.jpg"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDAxMDMyMTA5MDYzNDM=.jpg"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDAxMDMyMTA5MTgzNzU=.jpg"></p>
<p>好吧，不管他了。大概感受一下吧。由于我没看明白他的gabor函数怎么定义的，参数设置也不一样，实验结果很不相同，我希望我是对的，天地良心呐！！我只能按照维基百科给出的函数，编写了以下C代码：</p>
<pre>// my_gabor.cpp : 定义控制台应用程序的入口点。
//

#include "stdafx.h"
#include&lt;iostream&gt;
#include &lt;opencv2/core/core.hpp&gt;
#include &lt;opencv2/highgui/highgui.hpp&gt;
#include &lt;opencv2/imgproc/imgproc.hpp&gt;
#include "math.h"
#define  PI 3.1415926
#define  N 4
using namespace std;
using namespace cv;

void m_filer(double *src,int height,int width,double *mask_rel,double *mask_img,int mW,int mH,int k)
{
	IplImage *tmp;
	double a,b,c;
	char res[20];		//保存的图像名称

	tmp = cvCreateImage(cvSize(width,height),IPL_DEPTH_8U,1);

	for (int i = 0;i &lt; height;i++)
	{
		for (int j = 0;j &lt; width;j++)
		{
			a = 0.0;
			b = 0.0;
			c = 0.0;
			//去掉靠近边界的行列，无法滤波，超出范围
			if (i &gt; int(mH/2) &amp;&amp; i &lt; height - int(mH/2) &amp;&amp; j &gt; int(mW) &amp;&amp; j &lt; width - int(mW/2))
			{
				for (int m = 0;m &lt; mH;m++)
				{
					for(int n = 0;n &lt; mW;n++)
					{
						//printf("%f\n",src[(i+m-int(mH/2))*width+(j+n-int(mW))]);
						a += src[(i+m-int(mH/2))*width+(j+n-int(mW))]*mask_rel[m*mW+n];
						b += src[(i+m-int(mH/2))*width+(j+n-int(mW))]*mask_img[m*mW+n];
						//printf("%f,%f\n",a,b);
					}
				}
			}
			c = sqrt(a*a+b*b);
			c /= mW*mH;
			tmp-&gt;imageData[i*width+j] = (unsigned char)c;
		}
	}
	sprintf(res,"result%d.jpg",k);
	cvSaveImage(res,tmp);
	cvReleaseImage(&amp;tmp);
}

int _tmain(int argc, _TCHAR* argv[])
{
	IplImage *src;
	double *rel,*img,*src_data,xtmp,ytmp,tmp1,tmp2,tmp3,re,im;
	double Theta,sigma,Gamma,Lambda,Phi;		//公式中的5个参数
	int gabor_height,gabor_width,x,y;

	src = cvLoadImage("test.jpg",CV_LOAD_IMAGE_GRAYSCALE);
	gabor_height = 10;
	gabor_width = 10;
	Gamma = 1.0;
	Lambda = 10.0;
	sigma = 100;
	Phi = 0;

	rel = (double *)malloc(sizeof(double)*gabor_width*gabor_height);//实数部分
	img = (double *)malloc(sizeof(double)*gabor_width*gabor_height);//虚数部分
	src_data = (double *)malloc(sizeof(double)*src-&gt;widthStep*src-&gt;height);	//图像数据 

	for (int i=0;i&lt;src-&gt;height;i++)
	{
		for (int j=0;j&lt;src-&gt;widthStep;j++)
		{
			src_data[i*src-&gt;widthStep+j]=(unsigned char)src-&gt;imageData[i*src-&gt;widthStep+j];
			//printf("%f\n",src_data[i*src-&gt;widthStep+j]);
		}
	}

	//构造gabor函数
	for (int k = 0;k &lt; N;k++)					//定义N方向
	{
		Theta = PI*((double)k/N);
		for (int i = 0;i &lt; gabor_height;i++)	//定义模版大小
		{
			for (int j = 0;j &lt; gabor_width;j++)
			{
				x = j - gabor_width/2;
				y = i - gabor_height/2;

				xtmp = (double)x*cos(Theta) + (double)y*sin(Theta);
				ytmp = (double)y*cos(Theta) - (double)x*sin(Theta);

				tmp1 = exp(-(pow(xtmp,2)+pow(ytmp*Gamma,2))/(2*pow(sigma,2)));
				tmp2 = cos(2*PI*xtmp/Lambda + Phi);
				tmp3 = sin(2*PI*xtmp/Lambda + Phi);

				re = tmp1*tmp2;
				im = tmp1*tmp3;

				rel[i*gabor_width+j] = re;
				img[i*gabor_width+j] = im;
				//printf("%f,%f\n",re,im);
			}
		}
		//用不同方向的GABOR函数对图像滤波并保存图片
		m_filer(src_data,src-&gt;height,src-&gt;width,rel,img,10,10,k);
	}

	free(rel);free(img);free(src_data);
	return 0;
}
</pre>
<p>运行效果：<br />
<br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDAxMDMyMTEzMTI3OTY=.jpg">  <img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDAxMDMyMTEzMjExODc=.jpg">  <img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDAxMDMyMTEzNDE1MDA=.jpg">  <img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDAxMDMyMTEzNTA4NDM=.jpg"></p>
<p>大概就这样凑活吧。我这边实数部分和虚数部分的处理是采用求模的方式。有问题的，请广大人民群众提出来啊。</p>
<p>三、用gabor提取纹理特征的思路【抄别人的论文】</p>
<p>  Gabor滤波方法的主要思想是：不同纹理一般具有不同的中心频率及带宽，根据这些频率和带宽可以设计一组Gabor滤波器对纹理图像进行滤波，每个Gabor滤波器只允许与其频率相对应的纹理顺利通过，而使其他纹理的能量受到抑制，从各滤波器的输出结果中分析和提取纹理特征，用于之后的分类或分割任务。Gabor滤波器提取纹理特征主要包括两个过程：①设计滤波器(例如函数、数目、方向和间隔)；②从滤波器的输出结果中提取有效纹理特征集。Gabor滤波器是带通滤波器，它的单位冲激响应函数(Gabor函数)是高斯函数与复指数函的乘积。它是达到时频测不准关系下界的函数，具有最好地兼顾信号在时频域的分辨能力。</p>
<p>  实现步骤：</p>
<p>（1）将输入图像分为3×3（9块）和4×4（16块）的图像块；</p>
<p>（2）建立Gabor滤波器组：选择4个尺度，6个方向，这样组成了24个Gabor滤波器；</p>
<p>（3）Gabor滤波器组与每个图像块在空域卷积，每个图像块可以得到24个滤波器输出，这       些输出是图像块大小的图像，如果直接将其作为特征向量，特征空间的维数会很大，       所以需要“浓缩”；</p>
<p>（4）每个图像块经过Gabor滤波器组的24个输出，要“浓缩”（文中提到“average filter        responses within the block”我的理解是取灰度均值）为一个24×1的列向量作为该图像       块的纹理特征。查阅相关文献，发现也可以用方差。</p>
<p>    利用一幅真实图像，按照文献原文所说，利用4scales*6orientations的Gabor滤波器组进行纹理特征提取，可以有效获得图像纹理信息。其中，单独拿出某组相同scale的结果，展示如下所示。【别人的实验结果，也没给代码，我也没去做】</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDAxMDMyMTE4MDQ0Njg=.jpg"></p>
<p>好吧，今天写到这里，赶紧DOTA去了，有问题的一定要及时告诉我啊：）</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-28 15:21:48</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e5%87%bd%e6%95%b0/" title="函数">函数</a>, <a href="https://www.iamivan.net/tag/%e5%b8%a6%e5%ae%bd/" title="带宽">带宽</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Gabor滤波器学习的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MxWq7yb.html" rel="bookmark">Gabor滤波器提取特征向量的问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 Gabor滤波器提取特征向量的问题 如果我需要用Gabor滤波器得到关于一副图片的特征向量,我应该用什么特征值来作为特征向量?怎样用Gabor来提取这个特征值?			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b32VNJz.html" rel="bookmark">矩阵-gabor滤波器处理完图像，出现负数，该怎么处理</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 gabor滤波器处理完图像,出现负数,该怎么处理 gabor滤波器处理完图像,想做纹理分割,效果不是很好,而且图像矩阵出现负数,该怎么处理 解决方案 把负数强制范围限制,设置为正试试!还有可能是你的图像像素运算时,值已经超出了0-255范围,没有做限制造成的. 解决方案二: 请问你是怎样得到图像矩阵的,用灰度值?			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bKYnnWp.html" rel="bookmark">深度学习在人脸识别中的应用&mdash;&mdash;优图祖母模型的&OpenCurlyDoubleQuote;进化&rdquo;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				雷锋网按:本文转自腾讯优图,着重介绍了深度学习在人脸识别中的应用,首先回顾了人脸识别的历史,接着介绍优图在人脸识别中的优势,及其&quot;进化过程&quot;. 说到人工智能(Artificial Intelligence, AI)人们总是很容易和全知.全能这样的词联系起来.大量关于AI的科幻电影更给人工智能蒙上一层神秘的色彩.强如&lt;黑客帝国&gt;.&lt;机械公敌&gt;中的AI要翻身做主人统治全人类.稍弱点的&lt;机械姬&gt;里EVA懂得利用美貌欺骗中二程序员,杀死主人逃出升天.最不济也			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/boarQXp.html" rel="bookmark">2017年深度学习必读31篇论文（附下载地址）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				2017年即将擦肩而过,Kloud Strife在其博客上盘点了今年最值得关注的有关深度学习的论文,包括架构/模型.生成模型.强化学习.SGD &amp; 优化及理论等各个方面,有些论文名扬四海,有些论文则非常低调. 一如既往,首先,标准免责声明适用,因为今年仅与GAN有关的论文就超过1660篇.我肯定会有疏漏,试图缩减到每两周一篇论文,包含了Imperial Deep Learning Reading Group上的大量素材.无论如何,我们开始吧. 架构/模型 今年的Convnet网络架构已经少得多,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p86L0ob.html" rel="bookmark">Deep Learning（深度学习）学习笔记整理系列之（七）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				目录: 一.概述 二.背景 三.人脑视觉机理 四.关于特征        4.1.特征表示的粒度        4.2.初级(浅层)特征表示        4.3.结构性特征表示        4.4.需要有多少个特征? 五.Deep Learning的基本思想 六.浅层学习(Shallow Learning)和深度学习(Deep Learning) 七.Deep learning与Neural Network 八.Deep learning训练过程        8.1.传统神经网络的训练方法			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pn7G2oz.html" rel="bookmark">伯克利AI实验室最新发文：公布用于机器人抓取的Dexterity Network &lpar;Dex-Net&rpar; 2&period;0数据集</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				雷锋网AI科技评论按:伯克利AI实验室最新发文公布了用于机器人抓取的Dexterity Network (Dex-Net) 2.0数据集,这些数据集可以用来训练根据实际机器人的点云做抓取规划的神经网络. 本文作者为加州大学伯克利分校博士后研究员Jeff Mahler.雷锋网(公众号:雷锋网)全文翻译如下: 由于传感器噪声和遮挡的存在,物体的形状.位置和质量往往不能被精准确定,因此让机器人能够可靠地抓取各种不同的物体是很大的一项挑战. Dexterity Network(Dex-Net)2.0是一			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pPBrVrb.html" rel="bookmark">发展型机器人：由人类婴儿启发的机器人&period; 2&period;2  机器人学简介</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				2.2  机器人学简介 这一节主要是对机器人学中的重要术语和硬件技术进行介绍,主要目的是让不熟悉这些概念的读者更加容易理解后面的内容.机器人学中的一些专业术语会大量地出现在本书中,如自由度(D OF).红外传感器.电动或气动执行器.所以,认知科学和人类学专业的读者将会在这一章节中学到一些知识,可以说这一节是机器人学知识的入门简介.这部分的技术概述在一定程度上是基于Maja Matari＇c的&lt;The Robotics Primer&gt;(2007).读者可以通过参考该书了解更详细的内容.为了更进一			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MxWLgBb.html" rel="bookmark">一次竞赛案例的分享&mdash;&mdash;基于正则表达式的深度学习应用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文由北邮@爱可可-爱生活 老师推荐,阿里云组织翻译. 以下为译文: 最近我决定参加CrowdAnalytix主办的 Extraction of product attribute values竞赛,在这个网站上公司可以将数据处理的问题以外包的方式交给有能力处理的人.一直以来,我擅长的是图像和视频数据处理,而这次,我尝试着处理文本. 问题是从不同长度的产品标题和产品描述中提取出制造商零件编号(MPN),这是一个标准的正则表达式问题.在简单浏览数据之后,我发现大约有54000个训练样本.因此,我决			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bBK8DNM.html" rel="bookmark">在深入学习gnuradio之前你需要知道的</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文网站:http://radioware.nd.edu 在深入学习gnuradio之前你需要知道的 学习GNU Radio需要有一定电脑基础和深入的通信与信号处理知识,本文列举了一些有用的资源,包括教程.网页链接和一些在线教程.本教程的目的是帮助GNU Radio爱好者们为这个令人兴奋的工具做一些准备.  目录 1.对gnuradio有一个清楚的认识 2.为gnuradio编写程序 3.数字信号处理(DSP) 4.通信系统 5.准备好了吗? 相信你已经发现gnuradio中的乐趣,并且已经开始			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Lpdg6Mj.html" rel="bookmark" class="title">如何写软件设计文档</a>
					<div>
						软件设计的不同模型:瀑布式.快速原型法以及迭代式 自从1968年提出&quot;软件工程&quot;概念以来,软件开发领域对于借鉴传统工程的原则.方法,以提高质量.降低成本的探索就从未停止过.而在这个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OM9Z04p.html" rel="bookmark" class="title">FAQ：IIS - 我需要多大马力？（自MS）--IIS的配置需求</a>
					<div>
						iis 我有一个 Web 站点,目前浏览状况为一百万页视图/月.估计将要增长至一千万至一千五百万页视图/月.它是一个使用 SQL Server 7.0 的数据库.现在我们运行两台计算机. IIS,50 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/XMl34ab.html" rel="bookmark" class="title">掉掉注意了，如何动态加载用户控件（ascx）</a>
					<div>
						动态|加载|控件 注: 本方法是我同事李强原创 步骤一: 把ascx控件拖入设计窗口,然后转入html模式,保留定义如果你需要多个ascx的话,请全部拖入.但是把相应的内容删除.(因为我们需要动态加载 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/aM6g8Np.html" rel="bookmark" class="title">ASP&period;NET中不定级动态菜单的实现</a>
					<div>
						asp.net|菜单|动态 前日,根据客户需要,要根据如下的表动态生成如下的菜单:表中的数据是动态更新的. 我们平时IEWebContr来做菜单时都是在html中直接输入,也就是说是静态的,现在要做成 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M620qYM.html" rel="bookmark" class="title">Linux内核编译错误： make&colon; &ast;&ast;&ast; &lbrack;&period;tmp&lowbar;vmlinux1&rsqb; Error 1</a>
					<div>
						若编译内核出现如下情况: WARNING: modpost: Found 1 section mismatch(es). To see full details build your kernel w ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZORd4b.html" rel="bookmark" class="title">C语言函数大全&lpar;s开头&rpar;&lpar;2&rpar;</a>
					<div>
						函数名: setvisualpage 功能: 设置可见图形页号 用法: void far setvisualpage(int pagenum); 程序例: #include #include #inc ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPNXOrb.html" rel="bookmark" class="title">我是这么利用数据：23寸大屏幕</a>
					<div>
						公司在经费方面很苛刻,但是在面子上从不含糊,每个人都配备23寸以上的显示器就是确凿的证据. 有时我特别看不惯这样,大家本不需要这么大的玩意,登陆系统也是两侧大量的留白. 直到有一天我脑子发热,决定把这 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNELGob.html" rel="bookmark" class="title">解析Java体系结构对信息安全的支持</a>
					<div>
						Java语言拥有三大特征:平台无关性.网络移动性和安全性,而Java体系结构对这三大特征提供了强大的支持和保证,本文着重介绍Java体系结构对支持信息安全的原理和使用方法. Java体系结构 Java ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2yBroz.html" rel="bookmark" class="title">asp&period;net 将一个图片以二进制值的形式存入Xml文件中的实例代码</a>
					<div>
						这篇文章介绍了将一个图片以二进制值的形式存入Xml文件中的实例代码,有需要的朋友可以参考一下   复制代码 代码如下: try    {     int readByte = 0;        // ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pd6XNxb.html" rel="bookmark" class="title">win8文件视图一键同步如何设置以便快速找到某个文件</a>
					<div>
						在电脑上都保存着很多文件夹,如果想要找个文件,一个一个点击查看就太麻烦了,在win8系统下,可以设置文件视图一键同步.那么下面就是详细的操作步骤. 1.任意打开一个文件夹,然后点击左上角的&quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Myw688z.html" rel="bookmark" class="title">seo-关于百度搜索中文就能查到我的网站</a>
					<div>
						问题描述 关于百度搜索中文就能查到我的网站 我的服务器上有个网站,目前只能在地址栏中写我的网站地址,才能找到,用百度输入我网站的网站名却找不到,我需要怎么做 解决方案 那很正常,,你的排名可能在很后面 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnY1akM.html" rel="bookmark" class="title">Fusion-io加速OEM合作拓展企业级市场</a>
					<div>
						[天极网服务器频道6月27日消息]在Sandisk公司宣布以11亿美金全现金方式收购闪存厂商Fusion-io,Fusion-io近期频频和一些IT厂商建立合作关系.这不Fusion-io携手戴尔宣布 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1l633b.html" rel="bookmark" class="title">ResultSet关闭问题</a>
					<div>
						问题描述 我有一个分析程序,数据库连接使用的是长连接,所以每次执行SQL查询后,会关闭resultset和释放连接资源,运行一天是没有问题的,但是越往后,resultset关闭就越耗费时间,这样就导致 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5NmAaz.html" rel="bookmark" class="title">面对SDN，我们该怎么办？</a>
					<div>
						引言:回顾SDN的发展历史,可以发现:SDN作为一种新的网络体系结构,对网络学术圈和工业界都产生了深远的影响.SDN并不是昙花一现的网络技术新概念,而是一场网络领域的技术变革. 我们将如何应对这场变革 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4Nlm1M.html" rel="bookmark" class="title">android-把 button 放在框架布局 frame layout 左边的问题</a>
					<div>
						问题描述 把 button 放在框架布局 frame layout 左边的问题 在一个垂直的线性布局中设置了两个textviews,还有一个button和一个frame layout框架布局. 我要把 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boR136z.html" rel="bookmark" class="title">&OpenCurlyDoubleQuote;化反&rdquo;原创者阿木卸任乐视一切职务 贾跃亭战队即将解散</a>
					<div>
						8月24日雷锋网消息,今日,据媒体报道,乐视正在举行的内部会议上,贾跃亭在乐视最后一位重要&quot;老搭档&quot;,乐视移动总裁阿不力克木·阿不力米提宣布卸任一切职务. 阿木最近的消息,还要追溯 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pm60Bwz.html" rel="bookmark" class="title">CAP理论十二年回顾：&amp;quot&semi;规则&amp;quot&semi;变了</a>
					<div>
						CAP理论断言任何基于网络的数据共享系统,最多只能满足数据一致性.可用性.分区容忍性三要素中的两个要素.但是通过显式处理分区情形,系统设计师可以做到优化数据一致性和可用性,进而取得三者之间的平衡. 自 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/My3Ra8z.html" rel="bookmark" class="title">继承-java中到底为什么要用到抽象类？</a>
					<div>
						问题描述 java中到底为什么要用到抽象类? 比如有个类A,把它设置成abstract是为了不让它实例化,只能表示一个抽象的或者不具体的无法实例化的概念,但是就算不在这个A的前面加abstract照样 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqRRZZp.html" rel="bookmark" class="title">线程和事件监听</a>
					<div>
						问题描述 小弟最近碰到一个现成等待的问题在CANVAS中覆盖了keyPressed方法中wait了一个线程然后我再按键这个事件一直没有被监听到这是什么原因?主要功能是实现了一个窗帘的移动代码如下Can ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOmX4vM.html" rel="bookmark" class="title">使用dubbo分布式框架开发项目</a>
					<div>
						Dubbo概述 •Dubbo是一个分布式服务框架,致力于提供高性能和透明化的RPC远程服务调用方案,以及SOA服务治理方案 •Dubbo是阿里巴巴SOA服务化治理方案的核心框架,每天为2,000+个服 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgRexBb.html" rel="bookmark" class="title">shell学习笔记3---awk的执行过程&lpar;原创&rpar;</a>
					<div>
						awk_script的组成1.awk_script可以由一条或多条awk_cmd组成,两条awk_cmd之间一般以NEWLINE分隔2.awk_cmd由两部分组成: awk_pattern { act ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAAJVXM.html" rel="bookmark" class="title">注册表-oracle卸载之后服务还在怎么解决？</a>
					<div>
						问题描述 oracle卸载之后服务还在怎么解决? 如图:oracle下载之后还有服务存在,现在已删除注册表为: HKEY_LOCAL_MACHINESOFTWAREORACLE HKEY_LOCAL_ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ba755Xp.html" rel="bookmark" class="title">AI报告&colon;人工智能究竟对人类有何影响</a>
					<div>
						前言 人工智能(Artificial Intelligence,简称AI)是一系列技术的集合,其下包括机器学习.推理.感知和自然语言处理等.人工智能的概念和应用65年前就已开始,不过最近AI的进步和应 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkeRVEb.html" rel="bookmark" class="title">热点推荐：毁灭程序员的15个障碍</a>
					<div>
						会议,什么都不懂的经理,生产效率指标--这就是你和下一个伟大软件之间的天堑. 昨天必须得发布产品.用户争闹和咆哮某个缺失的功能.老板的老板说,我们最好迅速行动起来否则就炒我们的鱿鱼.感觉一切都有心无力 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M126Pap.html" rel="bookmark" class="title">ios2&period;0 视频通话，对方接受通话后，自己这边会收到Connect remote failure</a>
					<div>
						问题描述 2016-06-30 14:11:31:821 tuoqutech[7158:4f43] SEND: &lt;iq type=&quot;set&quot; id=&quot;9fef060 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8YmY9z.html" rel="bookmark" class="title">ztree-zTree的节点单击后怎么实现主内容进行跳转&quest;</a>
					<div>
						问题描述 zTree的节点单击后怎么实现主内容进行跳转? zTree的节点单击事件后怎么实现主内容的框架进行页面跳转? 解决方案 有个url属性可以实现跳转. 参考:http://www.ztree. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrqrE4b.html" rel="bookmark" class="title">buttonsprite-AndEngine关于ButtonSprite跳转</a>
					<div>
						问题描述 AndEngine关于ButtonSprite跳转 我已經实现ButtonSprite,但是不知道如何实现点击跳转! 本来已经按钮点击会改变颜色,但想在按钮加入点击按钮开始游戏的功能!!!求 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQj8KKM.html" rel="bookmark" class="title">JAVA Web&sol;WAP开发工程师（北京）</a>
					<div>
						问题描述 本公司是国外知名集团公司SK旗下的软件企业,立志成为智能交通信息服务和移动位置服务的领军企业.目前,公司在动态交通信息服务.终端解决方案.增值业务服务等3个业务领域取得快速的发展.现诚聘JA ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8NgZob.html" rel="bookmark" class="title">零基础上手Swift快速入门教程概览&lowbar;Swift</a>
					<div>
						Swift是苹果的品牌新的编程语言,在2014年WWDC(苹果开发者大会)上发布的编程语言. 随着Swift语言的发布,苹果也发布了一个出色的SWIFT的参考指南,这里强烈推荐. 但是这个学习指南又长 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2Z1wZb.html" rel="bookmark" class="title">PHP实现发送邮件的方法&lpar;基于简单邮件发送类&rpar;&lowbar;php技巧</a>
					<div>
						本文实例讲述了PHP实现发送邮件的方法.分享给大家供大家参考,具体如下: 邮件发送类 &lt;?php /*邮件发送类 *功能:使用smtp服务器发送邮件 */ class smtp { /* 全局变 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.030 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
